<!DOCTYPE html>
<html lang="en">

<head>
   <meta charset="utf-8" />
   <meta name="viewport" content="width=device-width, initial-scale=1" />
   <title>Quản lý đơn hàng</title>
   <!-- Google Font: Source Sans Pro -->
   <link rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback" />
   <!-- Font Awesome -->
   <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
   <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.2.0/css/all.min.css" />
   <!-- Theme style -->
   <link rel="stylesheet" href="dist/css/adminlte.min.css" />
   <!--data Table-->
   <link rel="stylesheet" href="https://cdn.datatables.net/1.12.1/css/dataTables.bootstrap4.min.css" />
</head>

<body class="hold-transition sidebar-mini">
   <!-- Site wrapper -->
   <div class="wrapper">
      <!-- Navbar -->
      <nav class="main-header navbar navbar-expand navbar-white navbar-light">
         <!-- Left navbar links -->
         <ul class="navbar-nav">
            <li class="nav-item">
               <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
            </li>
            <li class="nav-item d-none d-sm-inline-block">
               <a href="index3.html" class="nav-link">Home</a>
            </li>
            <li class="nav-item d-none d-sm-inline-block">
               <a href="#" class="nav-link">Order</a>
            </li>
         </ul>

         <!-- Right navbar links -->
      </nav>
      <!-- /.navbar -->

      <!-- Main Sidebar Container -->
      <aside class="main-sidebar sidebar-dark-primary elevation-4">
         <!-- Brand Logo -->
         <a href="index3.html" class="brand-link">
            <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
               style="opacity: 0.8" />
            <span class="brand-text font-weight-light">Quản lý Đơn hàng</span>
         </a>

         <!-- Sidebar -->
         <div class="sidebar">
            <!-- Sidebar user (optional) -->
            <div class="user-panel mt-3 pb-3 mb-3 d-flex">
               <div class="image">
                  <img src="dist/img/avatar2.png" class="img-circle elevation-2" alt="User Image" />
               </div>
               <div class="info">
                  <a href="#" class="d-block">Bao Tran</a>
               </div>
            </div>

            <!-- SidebarSearch Form -->
            <div class="form-inline">
               <div class="input-group" data-widget="sidebar-search">
                  <input class="form-control form-control-sidebar" type="search" placeholder="Search"
                     aria-label="Search" />
                  <div class="input-group-append">
                     <button class="btn btn-sidebar">
                        <i class="fas fa-search fa-fw"></i>
                     </button>
                  </div>
               </div>
            </div>

            <!-- Sidebar Menu -->
            <nav class="mt-2">
               <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                  data-accordion="false">
                  <!-- Add icons to the links using the .nav-icon class
                     with font-awesome or any other icon font library -->
                  <li class="nav-item menu-open">
                     <a href="#" class="nav-link active">
                        <i class="nav-icon fas fa-tachometer-alt"></i>
                        <p>
                           Dashboard
                           <i class="right fas fa-angle-left"></i>
                        </p>
                     </a>
                     <ul class="nav nav-treeview">
                        <li class="nav-item">
                           <a href="Order.html" class="nav-link active">
                              <i class="far fa-circle nav-icon"></i>
                              <p>Order</p>
                           </a>
                        </li>
                     </ul>
                  </li>
               </ul>
            </nav>
            <!-- /.sidebar-menu -->
         </div>
         <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content -->
      <div class="content-wrapper">
         <!-- Content Header (Page header) -->
         <section class="content-header">
            <div class="container-fluid">
               <div class="row mb-2">
                  <div class="col-sm-6">
                     <h1>Order</h1>
                  </div>
                  <div class="col-sm-6">
                     <ol class="breadcrumb float-sm-right">
                        <li class="breadcrumb-item"><a href="#">Home</a></li>
                        <li class="breadcrumb-item active">Order</li>
                     </ol>
                  </div>
               </div>
            </div>
            <!-- /.container-fluid -->
         </section>

         <!-- Main content -->
         <section class="content">

            <div class="container-fluid">
               <div class="text-center">
                  <h2>Dach Sách Order</h2>
               </div>
               <div class="jumbotron my-4">
                  <div class="row">
                     <div class="col-sm-2">
                        <label for="">Loại Pizza</label>
                     </div>
                     <div class="col-sm-3">
                        <select name="" id="select-find-loaiPizza" class="form-control">
                           <option value="all">All</option>
                           <option value="Seafood">Hải sản</option>
                           <option value="Hawaii">Hawaii</option>
                           <option value="Bacon">Thịt hun khói</option>
                        </select>
                     </div>
                     <div class="col-sm-2">
                        <label for="">Trạng Thái</label>
                     </div>
                     <div class="col-sm-3 col-lg-3">
                        <select name="" id="select-find-trangThai" class="form-control">
                           <option value="all">All</option>
                           <option value="open">Open</option>
                           <option value="cancel">Đã hủy</option>
                           <option value="confirmed">Đã xác nhận</option>
                        </select>
                     </div>
                     <div class="col-sm-2 text-center">
                        <button class="btn btn-success" id="btn-find">Tìm Kiếm</button>
                     </div>
                  </div>
               </div>
               <div class="form-group">
                  <button class="btn btn-success" id="btn-insert"><i class="fa fa-plus"></i>&nbsp; Thêm</button>
               </div>
               <table class="table table-striped table-hover table-bordered" id="order-table">
                  <thead>
                     <tr>
                        <th scope="col">STT</th>
                        <th scope="col">Order code</th>
                        <th scope="col">Kich co combo</th>
                        <th scope="col">Loai pizza</th>
                        <th scope="col">Nước uống</th>
                        <th scope="col">Thành tiền</th>
                        <th scope="col">Giảm Giá</th>
                        <th scope="col">Thanh Toán</th>
                        <th scope="col">Họ và tên</th>
                        <th scope="col">Số điện thoại</th>
                        <th scope="col">Trạng thái</th>
                        <th scope="col">Action</th>
                     </tr>
                  </thead>
                  <tbody></tbody>
               </table>
            </div>

            <!--Vùng update modal-->
            <div id="update-modal" class="modal" tabindex="-1" role="dialog">
               <div class="modal-dialog" role="document">
                  <div class="modal-content">
                     <div class="modal-header">
                        <h5 class="modal-title">Update Trạng Thái</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                           <span aria-hidden="true">&times;</span>
                        </button>
                     </div>
                     <div class="modal-body">
                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Order Code</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-orderCode" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Pizza Size</label>
                           </div>
                           <div class="col-sm-9">
                              <select name="" id="select-kichCo" class="form-control" disabled>
                                 <option value="S">S</option>
                                 <option value="M">M</option>
                                 <option value="L">L</option>
                              </select>
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Đường Kính</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-duongKinh" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Sườn</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-suon" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Salad</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-salad" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Pizza Type</label>
                           </div>
                           <div class="col-sm-9">
                              <select name="" id="inp-loaiPizza" disabled="disabled" class="form-control">
                                 <option value="Seafood">Hải sản</option>
                                 <option value="Hawaii">Hawaii</option>
                                 <option value="Bacon">Thịt Xông Khói</option>
                              </select>
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Id Voucher</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-idVourcher" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Thành Tiền</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-thanhTien" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Giảm GIá</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-giamGia" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Loại Đồ Uống</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-idLoaiNuocUong" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Số Lượng Nước Uống</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-soLuongNuoc" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Họ Tên</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-hoTen" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Email</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-email" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Số Điện Thoại</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-soDienThoai" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Địa Chỉ</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-diaChi" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Lời Nhắn</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-loiNhan" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Ngày order</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-ngayTao" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Ngày Chỉnh Sửa</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-ngayCapNhat" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Trạng Thái</label>
                           </div>
                           <div class="col-sm-9">
                              <select name="" id="select-trangThai" class="form-control">
                                 <option value="open">Open</option>
                                 <option value="cancel">Đã hủy</option>
                                 <option value="confirmed">Đã xác nhận</option>
                              </select>
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-12 text-right">
                              <button class="btn btn-info w-25" id="btn-update">Update</button>
                              <button type="button" class="btn btn-secondary w-25" data-dismiss="modal">Cancel</button>
                           </div>
                        </div>
                     </div>
                  </div>
               </div>
            </div>

            <!--Vùng modal xóa dữ liệu-->
            <div id="delete-modal" class="modal" tabindex="-1" role="dialog">
               <div class="modal-dialog" role="document">
                  <div class="modal-content">
                     <div class="modal-header">
                        <h5 class="modal-title">Xóa Order</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                           <span aria-hidden="true">&times;</span>
                        </button>
                     </div>
                     <div class="modal-body">
                        <form>
                           <p>Bạn có chắc chắn muốn xóa order này không?</p>
                        </form>
                     </div>
                     <div class="modal-footer">
                        <button type="button" class="btn btn-danger" id="btn-delete">Xác Nhận</button>
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                     </div>
                  </div>
               </div>
            </div>

            <!--Model Insert User-->
            <div id="insert-modal" class="modal" tabindex="-1" role="dialog">
               <div class="modal-dialog" role="document">
                  <div class="modal-content">
                     <div class="modal-header">
                        <h5 class="modal-title">Thêm Order</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                           <span aria-hidden="true">&times;</span>
                        </button>
                     </div>
                     <div class="modal-body">
                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Pizza Size</label>
                           </div>
                           <div class="col-sm-9">
                              <select name="" id="select-insert-kichCo" class="form-control">
                                 <option value="no_value">Chọn kích cỡ Pizza</option>
                                 <option value="S">S</option>
                                 <option value="M">M</option>
                                 <option value="L">L</option>
                              </select>
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Đường Kính</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-insert-duongKinh" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Sườn</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-insert-suon" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Salad</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-insert-salad" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Số Lượng Nước Uống</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-insert-soLuongNuoc" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Thành Tiền</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-insert-thanhTien" readonly />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Pizza Type</label>
                           </div>
                           <div class="col-sm-9">
                              <select name="" id="select-insert-loaiPizza" class="form-control">
                                 <option value="no_value">Chọn Pizza</option>
                                 <option value="Seafood">Hải sản</option>
                                 <option value="Hawaii">Hawaii</option>
                                 <option value="Bacon">Thịt Hun Khói</option>
                              </select>
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Id Voucher</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="number" class="form-control" id="inp-insert-idVourcher" />
                              <p id="p-notice"></p>
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Loại Đồ Uống</label>
                           </div>
                           <div class="col-sm-9">
                              <select name="" id="select-insert-idLoaiNuocUong" class="form-control">
                                 <option value="no_value">Chọn Loại Nước Uống</option>
                              </select>
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Họ Tên</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-insert-hoTen" />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Email</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-insert-email" />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Số Điện Thoại</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="number" class="form-control" id="inp-insert-soDienThoai" />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Địa Chỉ</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-insert-diaChi" />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-3">
                              <label for="">Lời Nhắn</label>
                           </div>
                           <div class="col-sm-9">
                              <input type="text" class="form-control" id="inp-insert-loiNhan" />
                           </div>
                        </div>

                        <div class="form-group row">
                           <div class="col-sm-12 text-right">
                              <button class="btn btn-success w-25" id="btn-insert-modal">Insert</button>
                              <button type="button" class="btn btn-secondary w-25" data-dismiss="modal">Cancel</button>
                           </div>
                        </div>
                     </div>
                  </div>
               </div>
            </div>


         </section>
         <!-- /.content -->
      </div>
      <!-- /.content-wrapper -->

      <footer class="main-footer">
         <div class="float-right d-none d-sm-block"><b>Version</b> 3.2.0</div>
         <strong>Copyright &copy; 2022-2023 <a href="https://adminlte.io">DevCamp</a>.</strong> All rights reserved.
      </footer>

      <!-- Control Sidebar -->

      <!-- Control sidebar content goes here -->
      </aside>
      <!-- /.control-sidebar -->
   </div>
   <!-- ./wrapper -->

   <!-- jQuery -->
   <script src="plugins/jquery/jquery.min.js"></script>
   <!-- Bootstrap 4 -->
   <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
   <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
   <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
   <!--JS của table -->
   <script>
      $(document).ready(function () {
         /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
         var gORDER_LIST = [];
         var gIdRow;
         var gDrinkList;
         var vIdVoucher;
         const gCOMBOPIZZA = [
            { kichCo: "S", duongKinh: 20, suon: 2, salad: 200, soLuongNuoc: 2, thanhTien: 150000 },
            { kichCo: "M", duongKinh: 25, suon: 4, salad: 300, soLuongNuoc: 3, thanhTien: 200000 },
            { kichCo: "L", duongKinh: 30, suon: 8, salad: 500, soLuongNuoc: 4, thanhTien: 250000 },
         ]

         var gCOLUMN_STT = 0;
         var gCOLUMN_ORDERCODE = 1;
         var gCOLUMN_KICHCO = 2;
         var gCOLUMN_LOAIPIZZA = 3;
         var gCOLUMN_NUOCUONG = 4;
         var gCOLUMN_THANHTIEN = 5;
         var gCOLUMN_GIAMGIA = 6;
         var gCOLUMN_THANHTOAN = 7;
         var gCOLUMN_HOTEN = 8;
         var gCOLUMN_SDT = 9;
         var gCOLUMN_TRANGTHAI = 10;
         var gCOLUMN_ACTION = 11;

         var gSTT = 1;

         var gColumn = [
            "stt",
            "orderCode",
            "kichCo",
            "loaiPizza",
            "idLoaiNuocUong",
            "thanhTien",
            "giamGia",
            "thanhToan",
            "hoTen",
            "soDienThoai",
            "trangThai",
            "action",
         ];

         $("#order-table").DataTable({
            columns: [
               { data: gColumn[gCOLUMN_STT] },
               { data: gColumn[gCOLUMN_ORDERCODE] },
               { data: gColumn[gCOLUMN_KICHCO] },
               { data: gColumn[gCOLUMN_LOAIPIZZA] },
               { data: gColumn[gCOLUMN_NUOCUONG] },
               { data: gColumn[gCOLUMN_THANHTIEN] },
               { data: gColumn[gCOLUMN_GIAMGIA] },
               { data: gColumn[gCOLUMN_THANHTOAN] },
               { data: gColumn[gCOLUMN_HOTEN] },
               { data: gColumn[gCOLUMN_SDT] },
               { data: gColumn[gCOLUMN_TRANGTHAI] },
               { data: gColumn[gCOLUMN_ACTION] },
            ],
            columnDefs: [
               {
                  targets: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11],
                  class: "text-center",
               },

               {
                  targets: gCOLUMN_STT,
                  render: function () {
                     return gSTT++;
                  },
               },
               {
                  targets: gCOLUMN_LOAIPIZZA,
                  render: function (res) {
                     switch (res) {
                        case "Seafood":
                           res = "Hải sản";
                           break;
                        case "Hawaii":
                           res = "Hawaii";
                           break;
                        case "Bacon":
                           res = "Thịt hun khói";
                           break;
                     }
                     return res;
                  },
               },
               {
                  targets: gCOLUMN_THANHTOAN,
                  render: function (data, type, row, meta) {
                     return row.thanhTien - row.giamGia;
                  },
               },

               {
                  targets: gCOLUMN_ACTION,
                  defaultContent: `<i class=" fa-sharp fa-solid fa-pen-to-square update-fa text-info" title="Update" style="cursor: pointer"></i>&nbsp;&nbsp;&nbsp;
                     <i class=" fa-solid fa-trash delete-fa text-danger" title="Delete" style="cursor: pointer"></i>`,
               },
               {
                  targets: gCOLUMN_TRANGTHAI,
                  render: function (res) {
                     switch (res) {
                        case "open":
                           res = "Open";
                           break;
                        case "cancel":
                           res = "Đã hủy";
                           break;
                        case "confirmed":
                           res = "Đã xác nhận";
                           break;
                     }
                     return res;
                  },
               },
            ],
         });

         /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
         //thêm sự kiện click cho các button
         $("#order-table").on("click", ".update-fa", function () {
            onBtnUpdateInTable(this);
         });
         $("#order-table").on("click", ".delete-fa", function () {
            onBtnDeleteInTable(this);
         });
         $("#btn-update").on("click", function () {
            onBtnUpdateInModal();
         });
         $("#btn-delete").on("click", function () {
            onBtnDeleteInModal();
         });
         $("#btn-insert").on("click", function () {
            onBtnInsertInTable();
         });
         $("#btn-insert-modal").on("click", function () {
            onBtnInsertInModal();
         });
         $("#btn-find").on("click", function () {
            onBtnFindClick();
         });





         $("#inp-insert-idVourcher").on("change", "", function () {
            vIdVoucher = $("#inp-insert-idVourcher").val()
            var vPhanTram = callApiVoucher(vIdVoucher)

            if (vPhanTram !== 0) {

               $("#p-notice").html(`Bạn được giảm ${vPhanTram}%`).css("color", "green").show()
            }
            else {
               $("#p-notice").html(`Không có mã voucher này`).css("color", "red").show()
            }
            if (vIdVoucher == "") {
               $("#p-notice").hide()
            }
         })

         onPageLoading();

         /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
         function onPageLoading() {
            callApiAllOrder();
            callApiDrinkList();
            loadDataToTable(gORDER_LIST);
            loadDataToDrinkSelect(gDrinkList);
         }

         //xử lý button Tìm Kiếm
         function onBtnFindClick() {
            var vTrangThai = $("#select-find-trangThai").val().toLowerCase();
            var vLoaiPizza = $("#select-find-loaiPizza").val().toLowerCase();
            var vFindResult = gORDER_LIST.filter(function (item) {
               return (
                  (vTrangThai == "all" || vTrangThai == item.trangThai.toLowerCase()) &&
                  (vLoaiPizza == "all" || vLoaiPizza == item.loaiPizza.toLowerCase())
               );
            });
            loadDataToTable(vFindResult);
         }

         //xử lý button Update ở Table
         function onBtnUpdateInTable(paramBtn) {
            getIdByRow(paramBtn);
            var ObjById = findObjByID(gIdRow);
            loadDataToUpdateModal(ObjById);
            $("#update-modal").modal("show");
         }

         //xử lý button Delete ở Table
         function onBtnDeleteInTable(paramBtn) {
            getIdByRow(paramBtn);
            $("#delete-modal").modal("show");
         }

         //xử lý button update trong modal
         function onBtnUpdateInModal() {
            var vObj = { trangThai: $("#select-trangThai").val() };

            callApiUpdateOrder(vObj);
         }

         //xử lý button delete trong modal
         function onBtnDeleteInModal() {
            callApiDeleteOrder();
         }

         //xử lý button Insert trong table
         function onBtnInsertInTable() {
            resetDataInsertTable();
            $("#select-insert-kichCo").on("change", function () {
               var vKichCo = $("#select-insert-kichCo").val();
               onChangeSelectKichCo(vKichCo);
            });
            $("#insert-modal").modal("show");
         }

         //xử lý button insert trong modal
         function onBtnInsertInModal() {
            //thu thập dữ liệu
            var vDataOrder = getDataFromInsertModal();
            console.log(vDataOrder);
            var validateData = validateDataOrder(vDataOrder);
            if (validateData) {
               callApiCreateOrder(vDataOrder);
            }
         }

         /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
         //gọi API tất cả order
         function callApiAllOrder() {
            $.ajax({
               async: false,
               type: "GET",
               url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
               success: function (res) {
                  gORDER_LIST = res;
               },
            });
         }

         //gọi API danh sách nước uống
         function callApiDrinkList() {
            $.ajax({
               async: false,
               type: "GET",
               url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
               success: function (res) {
                  gDrinkList = res;
               },
            });
         }

         //gọi API PUT để update đơn hàng
         function callApiUpdateOrder(paramObj) {
            $.ajax({
               type: "PUT",
               url: "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gIdRow,
               contentType: "application/json",
               data: JSON.stringify(paramObj),
               success: function () {
                  callApiAllOrder();
                  loadDataToTable(gORDER_LIST);
                  $("#update-modal").modal("hide");
               },
            });
         }

         //gọi API PUT để update đơn hàng
         function callApiDeleteOrder() {
            $.ajax({
               type: "DELETE",
               url: "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gIdRow,
               success: function (res) {
                  callApiAllOrder();
                  loadDataToTable(gORDER_LIST);
                  $("#delete-modal").modal("hide");
               },
            });
         }

         //gọi API POST để tạo đơn hàng
         function callApiCreateOrder(paramObj) {
            $.ajax({
               type: "POST",
               url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
               contentType: "application/json",
               data: JSON.stringify(paramObj),
               success: function () {
                  callApiAllOrder();
                  loadDataToTable(gORDER_LIST);
                  $("#insert-modal").modal("hide");
               },
            });
         }

         //gọi API POST để tạo đơn hàng
         function callApiVoucher(paramIdVoucher) {
            var vPhanTramGiamGia = 0;
            $.ajax({
               async: false,
               type: "GET",
               url: "http://203.171.20.210:8080/devcamp-pizza365/voucher_detail/" + paramIdVoucher,
               success: function (res) {
                  console.log(res);
                  vPhanTramGiamGia = res.phanTramGiamGia;
               },
            });
            return vPhanTramGiamGia;
         }

         //lấy giá trị ID của row được click
         function getIdByRow(paramBtn) {
            var vTrCLick = $(paramBtn).closest("tr");
            var vTable = $("#order-table").DataTable();
            var vIdRowClick = vTable.row(vTrCLick).data().id;
            gIdRow = vIdRowClick;
            console.log(gIdRow);
         }

         //tìm Order theo ID trong gORDER_LIST
         function findObjByID(paramId) {
            var vObjResult = [];
            var bI = 0;
            while (bI < gORDER_LIST.length) {
               if (paramId == gORDER_LIST[bI].id) {
                  vObjResult = gORDER_LIST[bI];
                  break;
               } else {
                  bI++;
               }
            }
            return vObjResult;
         }

         //tải dữ liệu vào bảng
         function loadDataToTable(paramObj) {
            gSTT = 1;
            var vTable = $("#order-table").DataTable();
            vTable.clear();
            vTable.rows.add(paramObj);
            vTable.draw();
         }

         //tải dữ liệu vào modal
         function loadDataToUpdateModal(paramObj) {
            $("#inp-diaChi").val(paramObj.diaChi);
            $("#inp-duongKinh").val(paramObj.duongKinh);
            $("#inp-email").val(paramObj.email);
            $("#inp-giamGia").val(paramObj.giamGia);
            $("#inp-hoTen").val(paramObj.hoTen);
            $("#inp-idLoaiNuocUong").val(paramObj.idLoaiNuocUong);
            $("#inp-idVourcher").val(paramObj.idVourcher);
            $("#select-kichCo").val(paramObj.kichCo);
            $("#inp-loiNhan").val(paramObj.loiNhan);
            $("#inp-ngayCapNhat").val(paramObj.ngayCapNhat);
            $("#inp-ngayTao").val(paramObj.ngayTao);
            $("#inp-orderCode").val(paramObj.orderCode);
            $("#inp-salad").val(paramObj.salad);
            $("#inp-soDienThoai").val(paramObj.soDienThoai);
            $("#inp-soLuongNuoc").val(paramObj.soLuongNuoc);
            $("#inp-suon").val(paramObj.suon);
            $("#inp-thanhTien").val(paramObj.thanhTien);
            $("#select-trangThai").val(paramObj.trangThai);
            $("#inp-loaiPizza").val(paramObj.loaiPizza);
         }

         //hàm load Dữ liệu nước vào option
         function loadDataToDrinkSelect(paramObj) {
            $.each(paramObj, function (index, item) {
               $("#select-insert-idLoaiNuocUong").append(
                  $("<option>", {
                     value: item.maNuocUong,
                     text: item.tenNuocUong,
                  })
               );
            });
         }

         //hàm thay đổi khi ấn select Kich co pizza
         function onChangeSelectKichCo(param) {
            for (let bI in gCOMBOPIZZA) {
               if (param == gCOMBOPIZZA[bI].kichCo) {
                  $("#inp-insert-duongKinh").val(gCOMBOPIZZA[bI].duongKinh);
                  $("#inp-insert-suon").val(gCOMBOPIZZA[bI].suon);
                  $("#inp-insert-salad").val(gCOMBOPIZZA[bI].salad);
                  $("#inp-insert-soLuongNuoc").val(gCOMBOPIZZA[bI].soLuongNuoc);
                  $("#inp-insert-thanhTien").val(gCOMBOPIZZA[bI].thanhTien);

               }
               if (param == "no_value") {
                  $("#inp-insert-duongKinh").val("");
                  $("#inp-insert-suon").val("");
                  $("#inp-insert-salad").val("");
                  $("#inp-insert-soLuongNuoc").val("");
                  $("#inp-insert-thanhTien").val("");
               }
            }
         }

         //hàm lấy data từ insert modal
         function getDataFromInsertModal() {
            var vDataOrder = {};
            vDataOrder.kichCo = $("#select-insert-kichCo").val();
            vDataOrder.duongKinh = Number($("#inp-insert-duongKinh").val());
            vDataOrder.suon = Number($("#inp-insert-suon").val());
            vDataOrder.salad = Number($("#inp-insert-salad").val());
            vDataOrder.soLuongNuoc = Number($("#inp-insert-soLuongNuoc").val());
            vDataOrder.thanhTien = Number($("#inp-insert-thanhTien").val());
            vDataOrder.loaiPizza = $("#select-insert-loaiPizza").val();
            vDataOrder.idVourcher = $("#inp-insert-idVourcher").val();
            vDataOrder.idLoaiNuocUong = $("#select-insert-idLoaiNuocUong").val();
            vDataOrder.hoTen = $("#inp-insert-hoTen").val();
            vDataOrder.email = $("#inp-insert-email").val();
            vDataOrder.soDienThoai = $("#inp-insert-soDienThoai").val();
            vDataOrder.diaChi = $("#inp-insert-diaChi").val();
            vDataOrder.loiNhan = $("#inp-insert-loiNhan").val();
            return vDataOrder;
         }

         //hàm kiểm tra thông tin nhập vào
         function validateDataOrder(paramObj) {
            var vRegexStrEmail = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;

            if (paramObj.kichCo == "no_value") {
               alert("Chọn kich cỡ");
               $("#select-insert-kichCo").focus();
               return false;
            }

            if (paramObj.loaiPizza == "no_value") {
               alert("Chọn Pizza");
               $("#select-insert-loaiPizza").focus();
               return false;
            }

            if (paramObj.idLoaiNuocUong == "no_value") {
               alert("Chọn Nước uống");
               $("#select-insert-idLoaiNuocUong").focus();
               return false;
            }

            if (paramObj.hoTen == "") {
               alert("Nhập họ tên");
               $("#inp-insert-hoTen").focus();
               return false;
            }

            if (paramObj.email !== "") {
               if (!vRegexStrEmail.test(paramObj.email)) {
                  alert("Email phải đúng định dạng");
                  $("#inp-insert-email").focus();
                  return false;
               }
            }

            if (paramObj.soDienThoai == "") {
               alert("Nhập số điện thoại");
               $("#inp-insert-soDienThoai").focus();
               return false;
            }

            if (paramObj.diaChi == "") {
               alert("Nhập địa chỉ");
               $("#inp-insert-diaChi").focus();
               return false;
            }

            return true;
         }

         //hàm xóa data trong InsertTable
         function resetDataInsertTable() {
            $("#select-insert-kichCo").val("no_value");
            $("#select-insert-loaiPizza").val("no_value");
            $("#inp-insert-kichCo").val("no_value");
            $("#inp-insert-idVourcher").val("");
            $("#select-insert-idLoaiNuocUong").val("no_value");
            $("#inp-insert-hoTen").val("");
            $("#inp-insert-email").val("");
            $("#inp-insert-soDienThoai").val("");
            $("#inp-insert-diaChi").val("");
            $("#inp-insert-loiNhan").val("");
            $("#p-notice").hide()
            $("#inp-insert-duongKinh").val("");
            $("#inp-insert-suon").val("");
            $("#inp-insert-salad").val("");
            $("#inp-insert-soLuongNuoc").val("");
            $("#inp-insert-thanhTien").val("");
         }

      });


   </script>

   <!-- AdminLTE App -->
   <script src="dist/js/adminlte.min.js"></script>
   <!-- AdminLTE for demo purposes -->
   4
</body>

</html>